#include "agentcost.hpp"

AgentCost::AgentCost()
{

}


double AgentCost::ComputeCost(WorldState* ws, WorldState* wsInit, Robot* r, bool forceRecompute, vector<double> weights)
{
    ws->load();
    if (costs.count(ws) == 1 && costs.at(ws).count(r) == 1 && !forceRecompute)
        return costs.at(ws).at(r);

    double cost = 0;

    GeometricComputations GC = GeometricComputations();

    if (r->getHriAgent()->type == HRI_PR2)
    {

        //Potential energie (only the height taken into account as the mass and gravity does not change)
        double potentialEnergie = 0;
        for(int i=5; i<12; i++)
        {
            potentialEnergie += r->getJoint(i)->getJointStruct()->abs_pos[2][3];
        }

        for(int i=15; i<22; i++)
        {
            potentialEnergie += r->getJoint(i)->getJointStruct()->abs_pos[2][3];
        }

        cost += (potentialEnergie/(14*global_Project->getActiveScene()->getBounds()[5]))*weights.at(0);


        //distance to Init
        if (wsInit)
        {
            double distInit = 0;
            int nbDof = 0;
            for(int i=0; i<22; i++)
            {
                nbDof +=r->getJoint(i)->getNumberOfDof();
                for (int j = 0; j< r->getJoint(i)->getNumberOfDof(); j++)
                {
                    double vmin,vmax;
                    r->getJoint(i)->getDofBounds(j,vmin,vmax);
                    double d = (*ws->getRobotConf(r))[r->getJoint(i)->getIndexOfFirstDof()+j] - (*wsInit->getRobotConf(r))[r->getJoint(i)->getIndexOfFirstDof()+j];
                    distInit +=d/(vmax-vmin);
                }
            }
            cost += fabs((distInit/nbDof)*weights.at(1));
        }


        //distance to human heads

        r->getHriAgent()->perspective->camjoint->abs_pos;

//        GC.distBetweenMatrix4(r->getHriAgent()->perspective->camjoint->abs_pos, )
//        PQP_Distance


        //divide by weights sum
        double weightadd = 0;
        for (unsigned int i = 0; i< weights.size(); i++)
        {
            weightadd+=weights.at(i);
        }
        cost = cost/weightadd;

        map<Robot*,double> m;
        m[r] = cost;
    }
    return cost;
}
