#ifndef GTPPLAN_HPP
#define GTPPLAN_HPP

#include "tools.hpp"
#include "WorldState.hpp"
#include <iostream>
#include <fstream>


class PlanTree
{
public:
    PlanTree();
    ~PlanTree();

    bool checkIfPlanInTree(OnePlan* OP);
    OnePlan* getPlanFromNode(PlanNode* PN);
    PlanNode* getNodeFromId(int idFirst, int idSecond);
    PlanNode* getNodeFormTS(TaskSolution* TS);

    bool addPlanNode(PlanNode* PN, TaskSolution *prevTS);

    void printAll();

    void printInFile(PlanNode* pn);

    vector<PlanNode*> getAllNodes() {return _tree;}

    double computeDist(PlanNode* p1, PlanNode* p2);

    PlanNode* getClosestNode(WorldState* ws, type_data td );



private:
    vector<PlanNode*> _tree;
    string myfilepath;

public:
    std::vector<double> getAllImpoInfo();
};


#endif // GTPPLAN_HPP
