#ifdef HATP_CONNECTION
#include "hatpconnection.hpp"
#include <jsoncpp/json/json.h>
#include <iostream>
#include <msgClient.hh>

HATPConnection::HATPConnection()
{
}





//int main(int argc, char ** argv){
//    //For data/Tests/test.dom
//    std::string hatpRequest("{\"HATP-REQ\": { \"REQ-TYPE\": \"plan\", \"REQ-ID\": 1, \"TASK-NAME\": \"Transfer_two_container\", \"PARAMETERS\": [\"C1\", \"C2\", \"L1\", \"L2\", \"R1\"]}}");

//    msgClient client;
//    client.connect("Tester", "localhost", 5500);

//    if(client.isConnected()){
//        client.sendMessage("HATP", hatpRequest);
//        std::pair<std::string, std::string> result = client.getBlockingMessage();
//        std::cout<<"#### Answer : \n"<<result.second;
//    }

//    exit(0);
//}


bool HATPConnection::connectMsgConnector()
{
    msgClient client;
    client.connect("move3d", "localhost", 5500);

    if(client.isConnected())
    {
        cout << "move3d is now connected" << endl;
        while (PlanEnv->getBool(PlanParam::GTP_msgconnector))
        {
//            g3d_draw_allwin_active();
            if (client.isMessageWaiting())
            {
                std::pair<std::string, std::string> result = client.getMessage();
                std::cout<<"#### Answer : \n"<<result.second << endl;
                string s = interpreteJson(result.second);
                if (s != "command")
                    client.sendMessage(result.first, s) ;
            }
            else
            {
                sleep(1);
            }
        }
        return true;
    }
    else
    {
        return false;
    }
}


const string &HATPConnection::interpreteJson(const string &u)
{
    _result = "";
    Json::Value root;
    Json::Reader reader;
    bool parsedSuccess = reader.parse(u, root, false);
    if(!parsedSuccess || root.size() <= 0)
    {
        // Report failures and their locations
        // in the document.
        cout<<"Failed to parse JSON"<< endl;
        _result = "";
        return _result;
    }

    Json::Value res(Json::objectValue);

    for( Json::ValueIterator itr = root.begin() ; itr != root.end() ; itr++ )
    {

        Json::Value localRes(Json::objectValue);
        string fct = "";
        fct = itr.key().asString();
        if (fct == "InitGTP")
        {
            if (TMI)
            {
               if (TMI->getInitWS())
               {
                  g3d_draw_allwin_active();
                  TMI->getInitWS()->load();
               }
               delete TMI;
            }

            TMI = new taskManagerInterface();
            global_Project->getActiveScene()->getFactsManager()->cleanWSList();
            TMI->initTaskManager();
//            PlanEnv->setBool(PlanParam::usingSpark,true);
            localRes["status"] = "OK";
            res[fct] = localRes;
            continue;
        }
        else if(!TMI)
        {
            cout<< "GTP not initialized" << endl;
            continue;
        }


        if (fct == "AddGTPAgent" )
        {
            Json::Value t = root[itr.key().asString()];
            string key = t["key"].asString();
            string val = t["value"].asString();
            TMI->setAgent(key,val);
            localRes["status"] = "OK";
        }
        else if (fct == "AddGTPConstraintArea" )
        {
            Json::Value t = root[itr.key().asString()];
            string name = t["nameId"].asString();
            string obj = t["Object"].asString();
            string area = t["area"].asString();
            bool supp = t["isSupport"].asBool();

            Robot* e = global_Project->getActiveScene()->getRobotByName(obj);

            TMI->getConstraints()->addConstraint(name, e, area , supp);
            localRes["status"] = "OK";
        }
        else if (fct == "AddGTPConstraintFact" )
        {
            Json::Value t = root[itr.key().asString()];
//            string key = t.begin().key().asString();
//            string val = t[t.begin().key().asString()].asString();
//            TMI->setAgent(key,val);

            string factType = t["factType"].asString();
            string factSubType = t["factSubType"].asString();
            string mainEntityName = t["mainEntity"].asString();
            string targetEntityName = t["targetEntity"].asString();
            bool boolValue = t["boolValue"].asBool();
            int valueType = t["valueType"].asInt();
            double specificValue = t["specificValue"].asInt();

            fact_id curFI;
            vector<fact_id> vf = global_Project->getActiveScene()->getFactsManager()->getFactList();

            curFI.factType = "none";
            for (unsigned int j = 0; j < vf.size(); j++)
            {
                fact_id tmp = vf.at(j);
                if (tmp.factType == factType && tmp.factSubType == factSubType)
                {
                    curFI = tmp;
                    break;
                }
            }

            if (curFI.factType == "none")
            {
                cout << "fact type not recognized" << endl;
                localRes["status"] = "ERROR";
                res[fct] = localRes;
                break;

            }

            Fact f(curFI);
            Robot* mainEntity = global_Project->getActiveScene()->getRobotByName(mainEntityName);
            if (!mainEntity)
            {
                cout << "no main entity found" << endl;
                localRes["status"] = "ERROR";
                res[fct] = localRes;
                break;
            }

            Robot* targetEntity = global_Project->getActiveScene()->getRobotByName(targetEntityName);

            if (!targetEntity)
            {
                cout << "no target entity found" << endl;
                localRes["status"] = "ERROR";
                res[fct] = localRes;
                break;
            }

            f.setIsComputed(false);
            f.setMainEntity(mainEntity);
            f.setTargetEntity(targetEntity);

            f.setBoolValue(boolValue);

            f.setValueType(valueType);
            f.setSpecValue(specificValue);

            TMI->getConstraints()->addConstraint(f);
            localRes["status"] = "OK";
        }
        else if (fct == "AddGTPData" )
        {
            Json::Value t = root[itr.key().asString()];
            string key = t["key"].asString();
            string val = t["value"].asString();
            TMI->addAdditinalData(key,val);
            localRes["status"] = "OK";
        }
        else if (fct == "AddGTPPoint" )
        {
            Json::Value t = root[itr.key().asString()];
            string key = t["key"].asString();
            p3d_point val;// = t["value"].asString();
            val.x = t["x"].asDouble();
            val.y = t["y"].asDouble();
            val.z = t["z"].asDouble();
            TMI->addPoint(key,val);
            localRes["status"] = "OK";
        }
        else if (fct == "AddGTPObject" )
        {
            Json::Value t = root[itr.key().asString()];
            string key = t["key"].asString();
            string val = t["value"].asString();
            TMI->setObject(key,val);
            localRes["status"] = "OK";
        }
        else if (fct == "Change_obj_col" )
        {
            Json::Value t = root[itr.key().asString()];
            string obj = t["object_name"].asString();
            int color = t["color"].asInt();
            p3d_rob* rob = p3d_get_robot_by_name(obj.c_str());
            cout << "previous color is : " << p3d_set_object_color(rob,color) << ", new color is : " << color << endl;
            localRes["status"] = "OK";
        }
        else if (fct == "CleanGTPPlan" )
        {
            TMI->getTaskManager()->getOnePlan()->clearPlan();
            localRes["status"] = "OK";
        }
        else if (fct == "ClearGTPInputs" )
        {
            TMI->clearAllInputs();
            localRes["status"] = "OK";
        }
        else if (fct == "DisableAllGTPFact" )
        {
            vector<fact_id> vfi =  global_Project->getActiveScene()->getFactsManager()->getFactList();
            vector<string> vs;
            for (unsigned int i = 0; i < vfi.size(); i++)
            {
              fact_id FI = vfi.at(i);
              bool isAlreadyIn = false;
              for (unsigned int j = 0; j < vs.size(); j++)
              {
                if (FI.factType == vs.at(j))
                {
                  isAlreadyIn = true;
                  break;
                }
              }
              if (!isAlreadyIn)
                vs.push_back(FI.factType);
            }


            for (unsigned int i = 0; i < vs.size(); i++)
            {
              global_Project->getActiveScene()->getFactsManager()->disableFacts(vs.at(i));
            }
            localRes["status"] = "OK";
        }
        else if (fct == "DisableGTPFact" )
        {
            Json::Value t = root[itr.key().asString()];
            string factType = t["factType"].asString();
            bool valueT = t["value"].asBool();
            bool test = false;
            if (valueT)
              test = global_Project->getActiveScene()->getFactsManager()->disableFacts(factType);
            else
              test = global_Project->getActiveScene()->getFactsManager()->enableFacts(factType);

            if (!test)
                localRes["status"] = "ERROR";
            else
                localRes["status"] = "OK";

        }
        else if (fct == "FindGTPTaskAlternative" )
        {
            Json::Value t = root[itr.key().asString()];
            int taskId = t["taskId"].asInt();
            bool computeMP = t["computeMP"].asBool();


            TMI->setComputeMP(computeMP);
            TMI->callAlternative(taskId);

            PlanNode* PN  = TMI->getCurrentPN();

            localRes["returnReport"] = TMI->getCurrentPN()->returnRepport;
            if (!PN->getTaskSolution())
            {
                printf("failed to find a solution");
            }
            else
            {
                localRes["taskId"] = PN->getId().first;
                localRes["taskAlternativeId"] = PN->getId().second;
                localRes["cost"] = PN->getTaskSolution()->getCost();
            }
            Json::Value planInfo(Json::objectValue);
            planInfo["planningTime"] = TMI->getCurrentPN()->timeComp*1000;
            planInfo["numberOfAttempt"] = (double)TMI->getCurrentPN()->nbTests/(double)TMI->getCurrentPN()->nbTotPossibleTests;
            localRes["planningInformation"] = planInfo;
        }
        else if (fct == "GetGTPFacts" )
        {
            Json::Value t = root[itr.key().asString()];

            int taskId = t["taskId"].asInt();
            int alternativeId = t["alternativeId"].asInt();

            if (taskId == -1 && alternativeId == -1)
            {
              cout << "Ids -1 -1" << endl;
              if(!TMI->getInitWS())
              {
                  localRes["status"] = "ERROR";
                  res[fct] = localRes;
                  break;
              }
              TMI->getInitWS()->load();
            }
            else
            {
                Task* t = TMI->getTaskManager()->getTask(taskId);
                if (!t)
                {
                    cout << "ERROR: no such task!" << endl;
                    localRes["status"] = "ERROR";
                    res[fct] = localRes;
                    break;
                }
                TaskSolution* TS = t->getResult()->getAlternativeWithId(alternativeId);
                if (!TS)
                {
                    cout << "ERROR: no such alternative!" << endl;
                    localRes["status"] = "ERROR";
                    res[fct] = localRes;
                    break;
                }

                TS->getStopWS()->load();
            }
            int id = global_Project->getActiveScene()->getFactsManager()->computeFacts(false);
            if (id == -1)
            {
                localRes["status"] = "ERROR";
                res[fct] = localRes;
                break;
            }
            WorldStateFacts* WSF = global_Project->getActiveScene()->getFactsManager()->getWSFromId(id);
            if (!WSF)
            {
                localRes["status"] = "ERROR";
                res[fct] = localRes;
                break;
            }
            vector<Fact> vf = WSF->getMeaningfulFacts();

            //if (vf.size() > NB_MAX_FACTS)
            //{
            //  list_gtp_facts->nbFacts = vf.size();
            //  *report = S_mhp_FAIL_FACTS_OVERFLOW_GTP;
            //  return ETHER;
            //}



            localRes["nbFacts"] = (int)vf.size();
            Json::Value facts(Json::arrayValue);

            for(unsigned int i = 0; i < vf.size(); i++)
            {
                Json::Value oneFact(Json::objectValue);

                oneFact["factType"] = vf.at(i).getType().factType;
                oneFact["factSubType"] = vf.at(i).getType().factSubType;
                //changing order for isreachable and isvisible
                if (!vf.at(i).getType().isMainAnAgent)
                {
                    oneFact["mainEntity"] = vf.at(i).getMainEntity()->getName();
                    oneFact["targetEntity"] = vf.at(i).getTargetEntity()->getName();
                }
                else
                {
                    oneFact["targetEntity"] = vf.at(i).getMainEntity()->getName();
                    oneFact["mainEntity"] = vf.at(i).getTargetEntity()->getName();
                }
                oneFact["isComputed"] = vf.at(i).isItComputed();
                oneFact["boolValue"] = vf.at(i).getBoolValue();
                oneFact["valueType"] = vf.at(i).getValueType();
                oneFact["specificValue"] = vf.at(i).getSpecValue();

                facts.append(oneFact);

            }

            localRes["facts"] = facts;
        }
        else if (fct == "PlanGTPTask" )
        {

            Json::Value t = root[itr.key().asString()];
            string type = t["type"].asString();
            int taskId = t["previousTaskId"].asInt();
            int taskAltId = t["previousTaskAlternativeId"].asInt();
            bool computeMP = t["computeMotionPlan"].asBool();
            cout << "computing for " << type << endl;

            WorldState *WS = NULL;
            if (taskId >= 0)
            {
              if (TMI->getTaskManager()->getTask(taskId))
              {
                TaskSolution* TS = TMI->getTaskManager()->getTask(taskId)->getResult()->getAlternativeWithId(taskAltId);
                if(TS)
                {
                   WS = TS->getStopWS();
                }
              }
            }
            if (!WS && taskId == -1 && taskAltId == -1)
            {
              cout << "Ids -1 -1" << endl;
              WS = TMI->getInitWS();
            }

            if (!WS)
            {
              cout << "no world state with this Ids, creating a new one from current" << endl;
              p3d_destroy_all_grasps();
              WS = new WorldState(global_Project->getActiveScene());
              WS->saveAll();
              WS->setAttachements(TMI->getAttachements());
            }

            TMI->setType(TMI->getTaskManager()->getTaskIdFromString(type));
            TMI->setTypeStr(type);

            TMI->setWorldState(WS);
            TMI->setComputeMP(computeMP);

            TMI->callGTP();
            TaskSolution* TSol = TMI->getCurrentSol();


            localRes["returnReport"] = TMI->getCurrentPN()->returnRepport;
            if (!TSol)
            {
                printf("failed to find a solution");
            }
            else
            {
                localRes["taskId"] = TSol->getTask()->getId();
                localRes["taskAlternativeId"] = TSol->getId();
                localRes["cost"] = TSol->getCost();
            }
            Json::Value planInfo(Json::objectValue);
            planInfo["planningTime"] = TMI->getCurrentPN()->timeComp*1000;
            planInfo["numberOfAttempt"] = (double)TMI->getCurrentPN()->nbTests/(double)TMI->getCurrentPN()->nbTotPossibleTests;
            localRes["planningInformation"] = planInfo;
        }
        else if (fct == "AddToList" )
        {
            Json::Value t = root[itr.key().asString()];
            string act = t.asString();
            TMI->setTypeStr(act);
            cout << "act = " << act << endl;
            TMI->setType(TMI->getTaskManager()->getTaskIdFromString(act));
            TMI->addCurrentTaskToList();
        }
        else if (fct == "ComputePlan" )
        {
            p3d_destroy_all_grasps();
            WorldState* WS = new WorldState(global_Project->getActiveScene());
            WS->saveAll();
            TMI->setWorldState(WS);
            TMI->computePlan(true,0);
        }
        else if (fct == "RemoveGTPConstFromSol" )
        {
            Json::Value t = root[itr.key().asString()];
            int taskId = t["taskId"].asInt();
            int alternativeId = t["alternativeId"].asInt();
            TMI->removeConstraintFromPrevTS(taskId, alternativeId);
            localRes["status"] = "OK";
        }
        else if (fct == "ResetAllGTP" )
        {
            Json::Value t = root[itr.key().asString()];
            cout << "not implemented yet" << endl;
            localRes["status"] = "ERROR";
        }
        else if (fct == "SetGTPInitState" )
        {
            WorldState* WS = new WorldState(global_Project->getActiveScene());
            WS->saveAll();
            TMI->setInitWS(WS);
            TMI->getTaskManager()->addWorldState(WS);
            localRes["status"] = "OK";
        }
        else if (fct == "COMMAND" )
        {
            if (root["COMMAND"].asString() == "CONNECT")
                cout << "connected to hatp" << endl;
            else if (root["COMMAND"].asString() == "EXIT")
                cout << "ended connection to hatp" << endl;
            _result = "command";
            return _result;
        }
        else if (fct == "PING" )
        {
            localRes["status"] = "OK";
        }
        else
        {
            cout << "HATPConnection: fonction not implemented yet" << endl;
            localRes["status"] = "ERROR";
        }

        res[fct] = localRes;

    }
    cout << res<< endl;
    Json::FastWriter wrt;
    _result = wrt.write(res);
    return _result;
}

#endif
