#ifndef FAKEPLACE_HPP
#define FAKEPLACE_HPP
#include "place.hpp"


class FakePlace : public Place
{
public:
    FakePlace();

    bool initAll();
    bool initialize();
    bool finalize();
    bool findCandidateSolutions();
    bool getRandomSol();
    bool findConfigurations();
    bool findTrajectories();
    bool setAgents(multimap<string,string> agents_name);
    bool setToSolution(int solutionId, bool computeMP);
    bool isPossibleMainAgent(Robot* r);
    double computeCost(int altId);
    string getDescr();

private:
    p3d_point _targetPointStc;
    vector<configPt> _rotations;
};

#endif // FAKEPLACE_HPP
