#ifndef FIXONWALL_HPP
#define FIXONWALL_HPP

#include "../virtualtask.hpp"
#include "Planner-pkg.h"

class fixOnWall : public ManipulationTask
{
public:
    fixOnWall();
    bool initAll();

    bool run(multimap<string,string> agents_name,
             multimap<string,string> objects_name,
             multimap<string,p3d_point> point3d,
             multimap<string,string> additionalData,
             WorldState* WS);

    virtual bool findCandidateSolutions();
    virtual bool getRandomSol();
    virtual bool findConfigurations();
    virtual bool findTrajectories();
    virtual bool computeSolutionTrajectories(int alternativeId);
    virtual bool setToSolution(int solutionId, bool computeMP);
//    virtual vector<TaskSubSolution *> setNextTraj(TaskSubSolution* doneTSS);
    virtual bool setAgents(multimap<string,string> agents_name);
    virtual bool setObjects(multimap<string,string> objects_name);
    virtual bool setPoints(multimap<string,p3d_point> points);
    virtual bool setdata(multimap<string,string> additionalData);
    virtual void smoothSolution(int alternativeId) {std::cout << "not implemented" << std::endl;}
    virtual string getDescr();
    virtual string getTextFromValues();

    double getConfigCost();


    virtual void showMainObjectRandomTransform() {}


    Robot* getMainAgent() {return mainAgent;}
private:
    GTP2DGrid* _grid;


    Robot* targetAgent;


    vector<GTP2DCell*> mainReach;
    vector<GTP2DCell*> targetReach;

    GTP2DCell* currMain;
    GTP2DCell* currTarget;
    vector<pair<GTP2DCell*,GTP2DCell*> > failedPairs;


    p3d_point _target1;
    p3d_point _target2;

    shared_ptr<Configuration> mainEndConf;
    shared_ptr<Configuration> targetEndConf;


};

#endif // FIXONWALL_HPP
