#ifndef GIVE_HPP
#define GIVE_HPP

using namespace std;
#include "GTP/virtualtask.hpp"
#include "Planner-pkg.h"

#define MAX_NBR_TEST 1000

class Give : public CooperativeTask
{
public:
    Give();
    bool initAll();
    bool initialize();
    bool finalize();
    bool findCandidateSolutions();
    bool getRandomSol();
    bool findConfigurations();
    bool findTrajectories();
    bool computeSolutionTrajectories(int alternativeId);
    bool setToSolution(int solutionId, bool computeMP);
//    virtual vector<TaskSubSolution*> setNextTraj(TaskSubSolution* doneTSS);
    bool setAgents(multimap<string,string> agents_name);
    bool setObjects(multimap<string,string> objects_name);
    bool setPoints(multimap<string,p3d_point> points);
    bool setdata(multimap<string,string> additionalData);
    bool setSupportObject(multimap<string,string> objects_name);
    void smoothSolution(int alternativeId);
    string getDescr();
    string getTextFromValues();

    bool setTargetPoint(multimap<string,p3d_point> points);


    bool findCurrentTestPoint();
    configPt findObjectConf();

    bool checkHumanReach();
    bool isObjectInSurface();



protected:

    gpGrasp _curGrasp;

    p3d_traj* approachTraj;
    p3d_traj* targetTraj;

    confPtr_t _confSol;

    confPtr_t _targetSol;


    bool _hasTargedPoint;
    p3d_point _targetPoint;

    p3d_point _currentTest;

//    vector<int> targetHandIds;
    vector<pair<int, p3d_point> > _targetShoulder;
    double _mainAgentReach;
    double _targetAgentReach;
    p3d_point _mainAgentShoulder;

    int _currTargetHandId;

};


#endif // GIVE_HPP
