#ifndef GOTO_HPP
#define GOTO_HPP

using namespace std;
#include "GTP/virtualtask.hpp"
#include "Planner-pkg.h"


class GoTo : public PrivateTask
{
public:
    GoTo();

    bool run(multimap<string,string> agents_name,
             multimap<string,string> objects_name,
             multimap<string,p3d_point> point3d,
             multimap<string,string> additionalData,
             WorldState* WS, bool computeMP);

    bool initAll();
    bool initialize();
    bool finalize();
    bool findCandidateSolutions();
    bool getRandomSol();
    bool findConfigurations();
    bool findTrajectories();
    bool computeSolutionTrajectories(int alternativeId);
//    virtual bool findAlternative();
    bool setToSolution(int solutionId, bool computeMP);
    double computeCost(int altId);
//    virtual vector<TaskSubSolution *> setNextTraj(TaskSubSolution* doneTSS);
    bool setAgents(multimap<string,string> agents_name);
    bool setObjects(multimap<string,string> objects_name);
    bool setPoints(multimap<string,p3d_point> points);
    bool setdata(multimap<string,string> additionalData);
    void smoothSolution(int alternativeId);
    string getDescr();
    string getTextFromValues();

    //0 None, 1 Right, 2 left, 3, both
    int checkHandAttachement();

    static bool compareCells (GTP2DCell* i, GTP2DCell* j);
    static double combineCosts(double distTraveled, double angleAndRot, double distToObj);



private:

    p3d_point _targetPoint;
    confPtr_t _targetConf;
    confPtr_t _extractConf;
    GTP2DGrid* _grid;

    p3d_traj* extractTraj;
    vector<p3d_point> _traj;

    bool isTargetAPoint;
    Robot* _targetObject;

    vector<GTP2DCell*> _reachableCells;

    unsigned int _idCurrentSol;

};

#endif // GOTO_HPP
