#ifndef MOVETO_HPP
#define MOVETO_HPP

using namespace std;
#include "GTP/virtualtask.hpp"
#include "Planner-pkg.h"


class MoveTo : public ManipulationTask
{
public:
    MoveTo();
    bool run(multimap<string,string> agents_name,
             multimap<string,string> objects_name,
             multimap<string,p3d_point> point3d,
             multimap<string,string> additionalData,
             WorldState* WS, bool computeMP);

    virtual TaskSolution* findAlternative(bool computeMP);

    virtual bool initAll();
    virtual bool initialize();
    virtual bool finalize();
    virtual bool findCandidateSolutions();
    virtual bool getRandomSol();
    virtual bool findConfigurations();
    virtual bool findTrajectories();
    virtual bool computeSolutionTrajectories(int alternativeId);
//    virtual bool findAlternative();
    virtual bool setToSolution(int solutionId, bool computeMP);
//    virtual vector<TaskSubSolution *> setNextTraj(TaskSubSolution* doneTSS);
    virtual bool setAgents(multimap<string,string> agents_name);
    virtual bool setObjects(multimap<string,string> objects_name);
    virtual bool setPoints(multimap<string,p3d_point> points);
    virtual bool setdata(multimap<string,string> additionalData);
    virtual void smoothSolution(int alternativeId);
    virtual string getDescr();
    virtual string getTextFromValues();
private:
    unsigned int current_grasp_id;
    std::vector<gpGrasp> graspList;
//    int _armId;

    p3d_traj* _traj;
    confPtr_t _targetConf;
    map<string,vector<double> > _fileInfo;

    string _configurationName;

    int armUsed;

};

#endif // MOVETO_HPP
