#ifndef PICK_HPP
#define PICK_HPP

using namespace std;
#include "GTP/virtualtask.hpp"
#include "Planner-pkg.h"


class Pick : public ManipulationTask
{
public:
    Pick();
    virtual bool initAll();
    virtual bool initialize();
    virtual bool finalize();
    virtual bool findCandidateSolutions();
    virtual bool getRandomSol();
    virtual bool findConfigurations();
    virtual bool findTrajectories();
    virtual bool computeSolutionTrajectories(int alternativeId);
//    virtual bool findAlternative();
    virtual bool setToSolution(int solutionId, bool computeMP);
//    virtual vector<TaskSubSolution *> setNextTraj(TaskSubSolution* doneTSS);
    virtual bool setAgents(multimap<string,string> agents_name);
    virtual bool setObjects(multimap<string,string> objects_name);
    virtual bool setPoints(multimap<string,p3d_point> points);
    virtual bool setdata(multimap<string,string> additionalData);
    virtual void smoothSolution(int alternativeId);
    virtual string getDescr();
    virtual string getTextFromValues();
    virtual double computeHeuristicCost();
    virtual double getSSSizeLeft();

    bool getGrasps();

    void correctConfigs();

protected:
    unsigned int current_grasp_id;
    map<int,vector<gpGrasp> >  graspLists;
//    int _armId;

    p3d_traj* approachTraj;
    p3d_traj* graspTraj;
    p3d_traj* escapeTraj;
    p3d_traj* closeHandTraj;

    bool _noArm;
    vector<armLabel> _availableArms;
};

#endif // PICK_HPP
