#ifndef PICK_MULTIRRT_HPP
#define PICK_MULTIRRT_HPP

using namespace std;
#include "GTP/virtualtask.hpp"
#include "Planner-pkg.h"


class Pick_MultiRRT : public ManipulationTask
{
public:
    Pick_MultiRRT();
    virtual bool init();
    virtual bool findCandidateSolutions();
    virtual bool getRandomSol();
    virtual bool findConfigurations();
    virtual bool findTrajectories();
    virtual bool computeSolutionTrajectories(int alternativeId);
//    virtual bool findAlternative();
    virtual bool setToSolution(int solutionId, bool computeMP);
//    virtual vector<TaskSubSolution *> setNextTraj(TaskSubSolution* doneTSS);
    virtual bool setAgents(multimap<string,string> agents_name);
    virtual bool setObjects(multimap<string,string> objects_name);
    virtual bool setPoints(multimap<string,p3d_point> points);
    virtual bool setdata(multimap<string,string> additionalData);
    virtual void smoothSolution(int alternativeId);
    virtual string getDescr();
    virtual string getTextFromValues();
private:
    unsigned int current_grasp_id;
    std::vector<gpGrasp> graspList;
    std::set<int> _alternativeIds;
    int _armId;

    std::vector<confPtr_t> graspConfClosedVect;
    std::vector<confPtr_t> graspConfOpenVect;
    std::vector<confPtr_t> approachConfVect;
    std::vector<confPtr_t> escapeConfVect;
    confPtr_t initConf;

    p3d_traj* approachTraj;
    p3d_traj* graspTraj;
    p3d_traj* escapeTraj;
    p3d_traj* closeHandTraj;
};

#endif // PICK_MULTIRRT_HPP
