#include "pickquad.hpp"
#include "API/project.hpp"
#include "tools.hpp"

#include "planner/plannerFunctions.hpp"
#include "planner/TrajectoryOptim/Classic/smoothing.hpp"

#ifdef LIGHT_PLANNER
#include "LightPlanner-pkg.h"
#endif

//####################### PickQuad ########################

PickQuad::PickQuad() : PickPlaceQuad() {

    type="pickquad";
    typeId = pickQuad;
    nbMaxLoops=20;
    result=NULL;
    _idCurrentSol=-1;

    nbParameters=2;
    nbGikCalled=0;
    nbTests=0;
    nbMPCalled=0;

    nbTotPossibleTests = nbMaxLoops;

    returnRepport="OK";
    _returnRepportcount=0;
    _returnRepportcountMax=0;

    _pick_goto_traj=NULL;
    _pick_arm_traj=NULL;
    _pick_approach_traj=NULL;
    _pick_traj=NULL;
    _pick_extract_traj=NULL;

    _place_goto_traj=NULL;
    _place_arm_traj=NULL;
    _place_traj=NULL;
    _place_extract_traj=NULL;

    _mainObject=NULL;
    _supportObject=NULL;
    _ghost=NULL;

    _param=NULL;

    is_pick=true;
    is_place=false;
    strcpy(_className,"PickQuad");

}

string PickQuad::getDescr()
{
    string s="Task: \nId \t\t= " + to_string(task_id) + "\nType \t\t= " + type;
    if(mainAgent)
        s+="\nMain agent \t\t= " + mainAgent->getName();
    if(_mainObject)
        s+="\nMain object \t= " + _mainObject->getName();
    return s;
}

string PickQuad::getTextFromValues()
{
    return "Task: " + type + ": navigate to object (mainObject) and pick it"
            + "\n    agents: "
            + "\n        mainAgent: [AGENT ID]"
            + "\n    objects: "
            + "\n        mainObect: [OBJECT ID]";
}
