#ifndef PLACE_MULTIRRT_HPP
#define PLACE_MULTIRRT_HPP

using namespace std;
#include "GTP/Tasks/place.hpp"
#include "Planner-pkg.h"






class Place_MultiRRT : public Place
{
public:
    Place_MultiRRT();
    virtual bool findCandidateSolutions();
    virtual bool getRandomSol();
    virtual bool findConfigurations();
    virtual bool findTrajectories();

private:
    std::set<int> _alternativeIds;
    int _placementIndex;

    std::vector<confPtr_t> graspConfClosedVect;
    std::vector<confPtr_t> graspConfOpenVect;
    std::vector<confPtr_t> approachConfVect;
    std::vector<confPtr_t> escapeConfVect;
    std::vector<confPtr_t> confSolVect;
    confPtr_t initConf;


    std::vector<gpPlacement> _placementListOnSupport;
};


#endif // PLACE_MULTIRRT_HPP
