#include "Chronometer.hpp"

char Chronometer::ChronometerException::_what[50]="chrono except";

Chronometer::Chronometer()
{
    reset();
}

void Chronometer::reset(){
    if(clock_gettime(CLOCK_MONOTONIC,&_ts)!=0){
        ChronometerException e;
        throw e;
    }
}

timespec Chronometer::getTimespec(){
    timespec ts_now;
    timespec duration;
    if(clock_gettime(CLOCK_MONOTONIC,&ts_now)!=0){
        ChronometerException e;
        throw e;
    }
    duration.tv_sec=ts_now.tv_sec-_ts.tv_sec;
    duration.tv_nsec=ts_now.tv_nsec-_ts.tv_nsec;
    if(duration.tv_nsec<0){
        duration.tv_sec--;
        duration.tv_nsec+=1e9;
    }else if(duration.tv_nsec>=1e9){
        duration.tv_sec++;
        duration.tv_sec-=1e9;
    }
    if (duration.tv_nsec>=1e10) {
        ChronometerException e;
        throw e;
    }
    return duration;
}


long int Chronometer::getNanoSec(){
    timespec duration=getTimespec();
    return duration.tv_sec*1e9+duration.tv_nsec;
}

double Chronometer::getMilliSec(){
    timespec duration=getTimespec();
    return duration.tv_sec*1e3+duration.tv_nsec/1e6;
}

long int Chronometer::getMicroSec(void){
    timespec duration=getTimespec();
    return duration.tv_sec*1e6+duration.tv_nsec/1e3;
}
