#include "Edge.h"
#include <stdexcept>


namespace mho {

Edge::Edge()
{
}

Edge::Edge(NodeInterface *n1, NodeInterface *n2, cost_t c){
    _cost = c;
    if(n1==0 || n2==0){

        std::invalid_argument e("null ptr passed to Edge::Edge(NodeInterface *n1, NodeInterface *n2, cost_t c)");
        throw e;
    }
    _nodes.first=n1;
    _nodes.second=n2;
}

NodeInterface* Edge::first(void){
    return this->_nodes.first;
}

NodeInterface* Edge::second(void){
    return this->_nodes.second;
}

NodeInterface* Edge::oppositeSideOf(NodeInterface* n){
    if(this->first() == n)
        return this->second();
    else if (this->second()==n)
        return this->first();
    else{
        return 0;
    }
}

cost_t Edge::getCost(void){return this->_cost;}
void Edge::setCost(cost_t c){_cost=c;}
void Edge::setFirst(NodeInterface* n){_nodes.first=n;}
void Edge::setSecond(NodeInterface* n){_nodes.second=n;}

} // namespace mho
